#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################
 

#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use LWP::Simple;
use fmspm;


&get_setup;
fmspm::check_spamb("addurl2.cgi", "header", "$data_dir");
$q = CGI->new;

#################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES


print "Content-type: text/html\n\n";

if ($q->param('fct') eq ""){&add_url;}

################



sub add_url
{

&mkdirps("$web_dir/imagefiles");

if ($q->param('p') == 1){ $premium_listing = "true"; }


$gsettings = new_gsettings tseek;


### IF REGISTRATION SYSTEM IS IN USE
if ($gsettings->{addurl_reg_system} eq "Yes")
	{
	$current_user_id = pseek::accesscheck("", "", "ADDURL_CL");
	}


$addurltext = pseek::get_file_contents("$data_dir/addurl2.txt");
@ctexts = split (/\n/, $addurltext);

### CHECK IF ALL FIELDS HAVE BEEN FILLED IN




if (($q->param('catid') eq "") and ($q->param('category_dropdown') eq "")) {&add_url_instructions;}

#### 0 You have to supply an email address.
if ($q->param('email') eq ""){$error_text = $ctexts[0];}

if ($q->param('catid') eq "")
	{
	#### 1 No category has been selected.
	if ($q->param('category_dropdown') eq ""){$error_text = $ctexts[1];}
	}

#### 2 Please provide a title for your listing.
if ($q->param('title') eq ""){$error_text = $ctexts[2];}

#### 3 Please provide a description for your listing.
if ($q->param('description') eq ""){$error_text = $ctexts[3];}

#### 4 The description you supplied is to long.
if (length($q->param('description')) > $gsettings->{diz_chars}){$error_text = $ctexts[4];}

#### 5 Please provide keywords for your listing.
if ($q->param('keywords') eq ""){$error_text = $ctexts[5];}

if ($gsettings->{addurl_present} ne "No")
	{
	#### 6 Please provide a URL for your listing.
	if ($q->param('url') eq ""){$error_text = $ctexts[6];}
	if ($q->param('url') eq "http://"){$error_text = $ctexts[6];}
	}


if ($gsettings->{addurl_reg_system} ne "Yes")
{
	if ($gsettings->{modify_pass_check} ne "No")
	{
	##### 7 Please provide a password for your listing.
	if ($q->param('password1') eq ""){$error_text = $ctexts[7];}
	
	##### 8 Please provide a password for your listing.
	if ($q->param('password2') eq ""){$error_text = $ctexts[8];}
	}
}

#### 9 The 2 passwords you entered do not match.
if ($q->param('password2') ne $q->param('password1')){$error_text = $ctexts[9];}

#### 10 The email address you supplied is not valid.
if ($q->param('email') !~ /@/){$error_text = $ctexts[10];}

#### 11 The email address you supplied is not valid.
if ($q->param('email') !~ /\./){$error_text = $ctexts[11];}

#### 12 Please supply an owner name for your listing.
if ($q->param('sname') eq ""){$error_text = $ctexts[14];}

### DO IMAGE AUTHENTICATION IF IT'S ENABLED
if ($gsettings->{img_auth} eq "Yes")
	{
	$img_auth_check = pseek::check_img_auth_cc;
	if ($img_auth_check eq "false") { $error_text = $ctexts[15]; }
	}



#### EXTRA FIELD/KEY OPERATIONS

$keydata = pseek::get_file_contents("$data_dir/keys.dat");
@akeys = split(/\n/, $keydata);
$nrc = 0;

foreach $kitem (@akeys)
{
($keyname, $visible, $size, $searched, $description_key, $na, $imagef, $numberfield, $req) = split (/\t/, $kitem); 

		if (($q->param($keyname) eq "") and ($req eq "Yes") and ($numberfield ne "Upload"))
			{
			#You have not completed all the required fields. Please complete the '%%extra_field%%' field.
			$ctexts[13] =~ s/%%extra_field%%/$description_key/g;
			$error_text = $ctexts[13];
			}
}



### DO RECIPROCAL LINK CHECK IF ENABLED

if (($gsettings->{enable_reciprocal} eq "Yes") and ($premium_listing ne "true"))
{

$recip = $q->param('reciprocal');

$recip_domain = &get_domain($recip);

	if ($gsettings->{reciprocal_link_back} =~ /$recip_domain/i)
		{
		$error_text = $ctexts[16];
		}
	elsif (length($recip) < 1)
		{
		$error_text = $ctexts[16];
		}
		else
		{
		$url_to_get = $q->param('reciprocal');
		my $recip_url_page = get($url_to_get) or $error_text = $ctexts[16] . "- @$ ";
		$reciprocal_link_back = $gsettings->{reciprocal_link_back};
		if ($recip_url_page !~ /$reciprocal_link_back/){ $error_text = $ctexts[16]; }
		}
		$recip =~ s/'/\\'/g;
}



if (($gsettings->{enable_reciprocal_premium} eq "Yes") and ($premium_listing eq "true"))
{
$recip = $q->param('reciprocal');

$recip_domain = &get_domain($recip);

	if ($gsettings->{reciprocal_link_back} =~ /$recip_domain/i)
		{
		$error_text = $ctexts[16];
		}
	elsif ($q->param('reciprocal') eq "")
		{
		$error_text = $ctexts[16];
		}
		else
		{
		$url_to_get = $q->param('reciprocal');
		my $recip_url_page = get($url_to_get) or $error_text = $ctexts[16];
		$reciprocal_link_back = $gsettings->{reciprocal_link_back};
		if ($recip_url_page !~ /$reciprocal_link_back/){ $error_text = $ctexts[16]; }
		}
		$recip =~ s/'/\\'/g;
}




### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


$url = $q->param('url');
$ip = $ENV{REMOTE_ADDR};








### CHECK FOR DUPLICATE URLS

pseek::remove_leading_spacing($url);

if ($gsettings->{addurl_check_duplicates} eq "Yes")
{
 if (($q->param('url') ne "") and ($q->param('url') ne "http://"))
  {

	if (substr($url, length($url) -1, 1) eq "/")
		{
		$EXRAC = " or (url = '" . substr($url, 0, length($url) - 1) . "')";
		}
	
	$sql = "SELECT lnkid FROM links WHERE (url = '$url') $EXRAC";
	
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}
	$rows = $sth->rows();
	
	#### 12 The listing you are trying to submit is already in our index.
	if ($rows > 0) { $error_text = $ctexts[12];}

  }
}




#### CHECK THAT UPLOADED IMAGE IS NOT TOO LARGE
if (($q->param('image') ne "") and ($gsettings->{enable_image_uploads} eq "Yes"))
	{
	
		### CHECK IF UPLOAD DIR EXISTS
		&mkdirps("$web_dir/imagefiles");
	
		$upload_filename = $q->param('image'); 
		$upload_filename =~ s/.*[\/\\](.*)/$1/;
		(@fext) = split (/\./, $upload_filename);
		$fnr = @fext;
		$fextension_uimage = $fext[$fnr -1];
		$ufname = "$web_dir/imagefiles/temp." . $fextension_uimage;

		### DO UPLOAD
		$upload_filehandle = $q->param('image');
		open UPLOADFILE, ">$ufname"; 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;		

		### CHECK FILE SIZE
		$flsize = (-s "$ufname");
		$maxfsize = $gsettings->{upload_max_filesize}; if ($maxfsize eq "") { $maxfsize = 100; }
		$maxfsize = $maxfsize * 1000;
		
		if ($flsize > $maxfsize) #### THE FILE YOU ARE TRYING TO UPLOAD IS TOO BIG (LARGER THAN THE ALLOWED FILE SIZE)
		{
		unlink($ufname);
		$error_text = $ctexts[17];
		}
		
		chmod(0644,$ufname); 
	}



########################

if ($error_text ne "")
	{
	&add_url_problem($error_text);
	}



### CHECK SPAM FILTERS
($kstatus, $kreason) = &check_spamfilters;
if (($kstatus > 0) and ($kreason ne ""))
	{
	### ADD URL SCREEN BUT URL NOT ADDED
	&addurl_fake ($kreason);
	}




#### ADD NEW LISTING

if (($q->param('catid') eq "") or ($q->param('catid') eq "!!catid!!"))
	{
	$cid = $q->param('category_dropdown'); 
	}
	else
	{
	$cid = $q->param('catid'); 
	}

$title = $q->param('title'); $title =~ s/'/\\'/g; $title = pseek::remove_html($title);

$description = $q->param('description'); $description =~ s/'/\\'/g;

if ($gsettings->{strip_html_code} eq "Yes") { $description = pseek::remove_html($description); }

$keywords = $q->param('keywords'); $keywords =~ s/'/\\'/g; $keywords = pseek::remove_html($keywords);
$url = $q->param('url'); $url =~ s/'/\\'/g; $url = pseek::remove_html($url);
$name = $q->param('sname'); $name =~ s/'/\\'/g; $name = pseek::remove_html($name);
$email = $q->param('email'); $email =~ s/'/\\'/g; $email = pseek::remove_html($email);

$timep = time();
$urldate = $timep;

$subscribed = $q->param('mlist');

$lnkpassword = $q->param('password1');  $lnkpassword =~ s/'/\\'/g;
$csuggest = $q->param('csuggestion'); $csuggest =~ s/'/\\'/g;  $csuggest = pseek::remove_html($csuggest);



#### GET CATEGORY CID'S
$cid =~ s/[^0-9]//g;
$sql = "SELECT * FROM dirs WHERE cid = '$cid'";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}
$selq = "";

while ( @row = $sth->fetchrow() )
	{
	for ($ms = 2; $ms < 18; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$selq = $selq . $row[$ms] . "/";
			}
		}
	}

$selq = substr($selq, 0, length($selq) - 1); 

$sth->finish;
$dbh->disconnect;




$cstring = pseek::get_cid_cat($selq);





if ($premium_listing eq "true")
	{
	$prem_entry = ", premium = '1'";
	}




#### IF THIS IS A PREMIUM LISTING ADD EXPIRY DATE


if ($premium_listing eq "true")
	{
	$ptemp = pseek::get_file_contents("$data_dir/prem.cfg");
	@psettings = split (/\n/, $ptemp);
	#$time = timelocal($sec,$min,$hours,$mday,$mon,$year);
	$expire_seconds = $psettings[1] * 86400;
	$expire_seconds = $expire_seconds + $timep;
	}




#### EXTRA FIELD/KEY OPERATIONS

$randomfname = rand(100000); $randomfname = int($randomfname); ### FOR FILE NAMES IF WE ARE GOING TO HAVE EXTRA FIELD FILE UPLOADS
$ecnt = 0;
foreach $kitem (@akeys)
{
($keyname, $visible, $size, $searched, $description1, $na, $imagef, $numberfield, $req) = split (/\t/, $kitem); 

$orig_keyname = $keyname;
$custkey = $keyname . "_cust";
$custkey_val = $q->param($keyname);
$custkey_val =~ s/'/\\'/g;

if ($gsettings->{strip_html_code} eq "Yes") { $custkey_val = pseek::remove_html($custkey_val); }


 ### IF UPLOAD FIELD
 if ($numberfield eq "Upload")
	{
	$uploadname = $q->param($keyname);
	
	### IF UPLOAD FILE NAME BOX IS BLANK AND UPLOAD REQUIRED
	if (($uploadname eq "") and ($req eq "Yes")) { &add_url_upload_required_problem($keyname, "BLANK"); } 
	
	if ($uploadname ne "")
		{
			$fextension = &get_file_extension($uploadname);
			$extf_sql = $extf_sql . ",$custkey = '$fextension'";
			$uploaded_filename = &upload_extra_field_file($keyname, $randomfname);
			push (@fileups, $uploaded_filename . ":" . $keyname . ":" . $fextension);
		}
		else
		{
			$extf_sql = $extf_sql . ",$custkey = ''";
		}
	}
	else ### NORMAL FIELD
	{
	$extf_sql = $extf_sql . ",$custkey = '$custkey_val'";
	}


### FOR WELCOME EMAIL
$email_efields[$ecnt] = $keyname . ":::" . $na;
$ecnt++;

}




### CONNECT TO DB

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


#### CONSTRUCT INSERT QUERY
$sql = "INSERT INTO links SET cid = '$cid',
										title = '$title',
										description = '$description',
										keywords = '$keywords',
										url = '$url',
										name = '$name',
										email = '$email',
										urldate = '$timep',
										subscribed = '$subscribed',
										lnkpassword = '$lnkpassword',
										newsubm = 'Y',
										csuggest = '$csuggest',
										cidsubm = '$cstring',
										userid = '$current_user_id',
										subs_expire = '$expire_seconds',
										extf3 = '$recip',
										extf4 = '$ip'
										$prem_entry
										$extf_sql
										";
										
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}


#### GET LAST INSERTED LINK-ID FROM DB
$sth = $dbh->prepare("SELECT lnkid FROM links WHERE lnkid = LAST_INSERT_ID()");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
while ( @row = $sth->fetchrow() ) {$last_insert_id = $row[0]; }  


#### IF AN IMAGE WAS UPLOADED THEN UPLOAD IMAGE AND IMAGE UPLOADS ARE ENABLED

$uploaded_filename = "$web_dir/imagefiles/temp." . $fextension_uimage;



if (($q->param('image') ne "") and ($gsettings->{enable_image_uploads} eq "Yes") and (-e "$uploaded_filename"))
	{
	
		$ufname = $last_insert_id . "." . $fextension_uimage;
		$ufname = "$web_dir/imagefiles/$ufname";

		$returned = rename("$uploaded_filename","$ufname");

		### UPDATE DB TO INDICATE THAT THE LINK HAS AN IMAGE
		$sth = $dbh->prepare("UPDATE links SET image = '$fextension_uimage' WHERE lnkid = '$last_insert_id'");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}	

	}






$sth->finish;
$dbh->disconnect;



##### UPLOAD/COPY EXTRA FIELD IMAGES IF ANY

foreach $item (@fileups)
	{
	($curr_filename, $ufieldname, $field_ext) = split (/:/, $item);

			&mkdirps("$web_dir/imagefiles/$last_insert_id");
			$wfilename = "$web_dir/imagefiles/$last_insert_id/" . $ufieldname . "." . $field_ext;

			open (UPLOADFILE, "$data_dir/tmp/$curr_filename");
			open (UPLWRITE, "> $wfilename");

			  binmode (UPLOADFILE);
			  binmode (UPLWRITE);
			  
			  	while (defined($line=<UPLOADFILE>))
					{
					print UPLWRITE $line;
					}
			  
			close (UPLOADFILE);
			close (UPLWRITE);
			
			$stunlink = unlink("$data_dir/tmp/$curr_filename");
	}




###### GET PREMIUM LISTING SETTINGS

if ($premium_listing eq "true")
	{
	$ptemdata = pseek::get_file_contents("$data_dir/prem.cfg");
	@prem_settings = split (/\n/, $ptemdata);
	}


###### SEND WELCOME EMAIL

if (($gsettings->{welcome_email} eq "Yes") and ($premium_listing ne "true"))
	{
	$wlecome_email = pseek::get_file_contents("$data_dir/welcome.eml");
	}
	
if (($prem_settings[2] eq "Yes") and ($premium_listing eq "true"))
	{
	$wlecome_email = pseek::get_file_contents("$data_dir/pwelcome.eml");
	}


if ($wlecome_email ne "")
	{
	@elines = split (/\n/, $wlecome_email);
	
	$from_name = $elines[0];
	$from_email = $elines[1];
	$email_subject = $elines[2];
	
	$lnc = 0;
	foreach $line (@elines)
		{
		if ($lnc > 2)
			{
			$email_message = $email_message . $line . "\n";
			}
		$lnc++;
		}


	$udate =  pseek::decode_date($timep);

	$email_message =~ s/%%title%%/$title/gi;
	$email_message =~ s/%%description%%/$description/gi;
	$email_message =~ s/%%keywords%%/$keywords/gi;
	$email_message =~ s/%%url%%/$url/gi;
	$email_message =~ s/%%name%%/$name/gi;
	$email_message =~ s/%%email%%/$email/gi;
	$email_message =~ s/%%date%%/$udate/gi;
	$email_message =~ s/%%category_submitted%%/$selq/gi;
	$email_message =~ s/%%password%%/$lnkpassword/gi;	
	
	
	
	### INSERT EXTRA KEY FIELD DATA
	foreach $kf_item(@email_efields)
		{
		($kvalue, $na_text) = split (/:::/, $kf_item);
		
		$kvalue1 = $q->param($kvalue);
		
		if ($kvalue1 eq "") { $kvalue1 = $na_text; }
		
		$email_message =~ s/%%$kvalue%%/$kvalue1/g;
		}
	
	
	#$sendername1, $fromemail1, $toemail1, $mail_subject1, $email_message1
	
	$email_message =~ s/\\'/'/g;
	
	pseek::send_email ($from_name, $from_email, $email, $email_subject, $email_message); 
	}



####### SEND INFORMER EMAIL


if (($gsettings->{informer_email} eq "Yes") and ($premium_listing ne "true"))
	{
	$inf_email = pseek::get_file_contents("$data_dir/informer.eml");
	}

if (($prem_settings[3] eq "Yes") and ($premium_listing eq "true"))
	{
	$inf_email = pseek::get_file_contents("$data_dir/pinformer.eml"); 
	}


if ($inf_email ne "")
	{

	@elines1 = split (/\n/, $inf_email);
	
	$from_name = $elines1[0];
	$from_email = $elines1[1];
	$email_subject = $elines1[2];
	
	$email_message = "";
	
	$lnc = 0;
	foreach $line (@elines1)
		{
		if ($lnc > 2)
			{
			$email_message = $email_message . $line . "\n";
			}
		$lnc++;
		}

	$udate =  pseek::decode_date($timep);

	$email_message =~ s/%%title%%/$title/gi;
	$email_message =~ s/%%description%%/$description/gi;
	$email_message =~ s/%%keywords%%/$keywords/gi;
	$email_message =~ s/%%url%%/$url/gi;
	$email_message =~ s/%%name%%/$name/gi;
	$email_message =~ s/%%email%%/$email/gi;
	$email_message =~ s/%%date%%/$udate/gi;
	$email_message =~ s/%%category_submitted%%/$selq/gi;
	$email_message =~ s/%%password%%/$lnkpassword/gi;	

	### INSERT EXTRA KEY FIELD DATA
	foreach $kf_item(@email_efields)
		{
		($kvalue, $na_text) = split (/:::/, $kf_item);
		
		$kvalue1 = $q->param($kvalue);
		
		if ($kvalue1 eq "") { $kvalue1 = $na_text; }
		
		$email_message =~ s/%%$kvalue%%/$kvalue1/g;
		}
	
	#$sendername1, $fromemail1, $toemail1, $mail_subject1, $email_message1
	pseek::send_email ("Submission Robot", $from_email, $from_name, $email_subject, $email_message); 

	}






if ($premium_listing eq "true")
	{
	if ($prem_settings[0] eq "")
		{
		$prem_settings[0] = "$web_url/sample_orderf.html";
		}
	#print "Location: $prem_settings[0]\n\n";
	

$prem_settings[0] =~ s/!!cid!!/$cid/gi;
$prem_settings[0] =~ s/!!title!!/$name/gi;
$prem_settings[0] =~ s/!!description!!/$description/gi;
$prem_settings[0] =~ s/!!keywords!!/$keywords/gi;
$prem_settings[0] =~ s/!!url!!/$url/gi;
$prem_settings[0] =~ s/!!email!!/$email/gi;
$prem_settings[0] =~ s/!!name!!/$name/gi;

	
print <<END_OF_REDIRECT;
<html>
<head>
<title>Add URL</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$prem_settings[0]">
</head>
<body>
</body>
</html>
END_OF_REDIRECT
exit;
	
	}
	else
	{

	### IF CHARGING FOR STANDARD LINKS
	$ptemdata = pseek::get_file_contents("$data_dir/prem.cfg");
	@prem_settings = split (/\n/, $ptemdata);
	if ($prem_settings[7] ne "")
		{
print qq[
<html>
<head>
<title>Add URL</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$prem_settings[7]">
</head>
<body>
</body>
</html>
];
exit;
		}


	if ($gsettings->{addurl_reg_system} eq "Yes")
		{
		$addurl_tmpl = pseek::get_file_contents("$data_dir/rgs_add_url_success.html");
		}
		else
		{
		$addurl_tmpl = pseek::get_file_contents("$data_dir/add_url_success.html");
		}

	$addurl_tmpl = pseek::ts_insert_template_includes($addurl_tmpl);
	$addurl_tmpl = pseek::fill_vars($addurl_tmpl); 
	#$addurl_tmpl =~ s/!!scripts_url!!/$script_url/g;


		if ($gsettings->{searchmeth} eq "fulltext")
			{
			$addurl_tmpl =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
			}
			else
			{
			$addurl_tmpl =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
			}


	$addurl_tmpl =~ s/!!cid!!/$cid/gi;
	$addurl_tmpl =~ s/!!title!!/$name/gi;
	$addurl_tmpl =~ s/!!description!!/$description/gi;
	$addurl_tmpl =~ s/!!keywords!!/$keywords/gi;
	$addurl_tmpl =~ s/!!url!!/$url/gi;
	$addurl_tmpl =~ s/!!email!!/$email/gi;
	$addurl_tmpl =~ s/!!name!!/$name/gi;

 		
	$addurl_tmpl =~ s/!build_url!/$web_url/g;
	$addurl_tmpl =~ s/!!build_url!!/$web_url/g;
	$addurl_tmpl =~ s/%%problem%%/$error_text/g;
	print $addurl_tmpl;	
	}



}





sub addurl_fake 
{


my ($KWBlockReason) = @_;

$fields{'subdiz'} = &remove_carriage($fields{'subdiz'});


open (BLOG, ">> $data_dir/sfiltlog.log");
	print BLOG 	$KWBlockReason . ":::" .				 #### BLOCK REASON
					$q->param('email') . ":::" .			 #### EMAIL ADDRESS
					$q->param('title') . ":::" . 			 #### TITLE
					$q->param('description') . ":::" . 	 #### DESCRIPTION
					$q->param('keywords') . ":::" . 		 #### KEYWORDS
					$q->param('url') . ":::" . "\n";		 #### URL
close (BLOG);




	if ($gsettings->{addurl_reg_system} eq "Yes")
		{
		$addurl_tmpl = pseek::get_file_contents("$data_dir/rgs_add_url_success.html");
		}
		else
		{
		$addurl_tmpl = pseek::get_file_contents("$data_dir/add_url_success.html");
		}
	
	
	$addurl_tmpl = pseek::ts_insert_template_includes($addurl_tmpl);
	$addurl_tmpl = pseek::fill_vars($addurl_tmpl); 
	$addurl_tmpl =~ s/!!scripts_url!!/$script_url/g;


		if ($gsettings->{searchmeth} eq "fulltext")
			{
			$addurl_tmpl =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
			}
			else
			{
			$addurl_tmpl =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
			}

 		
	$addurl_tmpl =~ s/!build_url!/$web_url/g;
	$addurl_tmpl =~ s/!!build_url!!/$web_url/g;
	$addurl_tmpl =~ s/%%problem%%/$error_text/g;
	print $addurl_tmpl;	exit;


}





sub check_spamfilters
{


$s_title = $q->param('title');
$s_diz = $q->param('description');
$s_keyw = $q->param('keywords');
$s_email = $q->param('email');
$s_url = $url;
#$url

#### MATCH SPAM FILTER KEYWORDS
$sql = "SELECT * FROM spamfilter WHERE typefilter = 'K'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}
$rows = $sth->rows();

$crit1 = chr(10); $crit2 = chr(13);
while ( @row = $sth->fetchrow() )
	{ 
	$match_kw = $row[1];
	if ($row[3] eq "W") ### MATCH WHOLE WORDS
		{
		if ($s_title =~ /\b$match_kw\b/) {$MatchFound = 1;  $BlockReason = $BlockReason . "'$row[1]' matched in title.\n";}
		if ($s_diz =~ /\b$match_kw\b/) {$MatchFound = 1;  $BlockReason = $BlockReason . "'$row[1]' matched in description.\n";}
		if ($s_keyw =~ /\b$match_kw\b/) {$MatchFound = 1;  $BlockReason = $BlockReason . "'$row[1]' matched in keywords.\n";}
		}
		else
		{
		if ($s_title =~ /$match_kw/) {$MatchFound = 1;  $BlockReason = $BlockReason . "'$row[1]' partialy matched in title.\n";}
		if ($s_diz =~ /$match_kw/) {$MatchFound = 1;  $BlockReason = $BlockReason . "'$row[1]' partialy matched in description.\n";}
		if ($s_keyw =~ /$match_kw/) {$MatchFound = 1;  $BlockReason = $BlockReason . "'$row[1]' partialy matched in keywords.\n";}
		}
	}
	


### MATCH EMAIL ADDRESSES
$sql = "SELECT * FROM spamfilter WHERE typefilter = 'E'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}
$rows = $sth->rows();

$crit1 = chr(10); $crit2 = chr(13);
while ( @row = $sth->fetchrow() )
	{ 
	$match_kw = $row[1];
	if ($row[3] eq "W") ### MATCH WHOLE WORDS
		{
		if ($s_email eq $match_kw) {$MatchFound = 1;  $BlockReason = $BlockReason . "'$row[1]' matched email address.\n";}
		}
		else
		{
		if ($s_email =~ /$match_kw/) {$MatchFound = 1;  $BlockReason = $BlockReason . "'$row[1]' partialy matched email address.\n";}
		}
	}


#if ($rows > 0) {$MatchFound = 1;  $BlockReason = $BlockReason . "Email Address matched '$s_email'\n";}


### MATCH DOMAINS
$domain_name = &get_domain($url);

if ($domain_name ne "")
{
$sql = "SELECT * FROM spamfilter WHERE typefilter = 'D' AND criteria like '%$domain_name%'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}
$rows = $sth->rows();
if ($rows > 0) {$MatchFound = 1;  $BlockReason = $BlockReason . "Domain name matched '$domain_name'\n";}
}


#print "--> $domain_name - $MatchFound <BR>"; exit;

### IP MATCH
$domain_name = &get_domain($url);
$sql = "SELECT * FROM spamfilter WHERE typefilter = 'I' AND criteria = '$ip'";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}
$rows = $sth->rows();
if ($rows > 0) {$MatchFound = 1;  $BlockReason = $BlockReason . "IP Address matched '$ip'\n";}


### IF SUBMISSION BLOCKED UPDATE BLOCKED LOG

if ($MatchFound == 1)
	{
	$s_title =~ s/'/\\'/g;
	$s_diz =~ s/'/\\'/g;
	$s_keyw =~ s/'/\\'/g;
	$s_url =~ s/'/\\'/g; 
	$s_email =~ s/'/\\'/g;
	$s_sname = $q->param('sname'); $s_sname =~ s/'/\\'/g;
	$BlockReason =~ s/'/\\'/g;
	
	
	$current_time = time();
	($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
	$year = $year + 1900;
	$mon++; 
	$stat_date = $year . "-" . $mon . "-" . $mday; 
	
	$sql = "INSERT INTO blocklog SET title = '$s_title',
												description = '$s_diz',
												keywords = '$s_keyw',
												url = '$s_url',
												email = '$s_email',
												contact = '$s_sname',
												add_date = '$stat_date',
												ip = '$ip',
												reason = '$BlockReason'
												";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror \n From: $sql";}
	}

return ($MatchFound, $BlockReason);

}




sub part_match
{

my ($mtext, $mcrit) = @_;
my ($RETVal);

$RETVal = 0;

$mcrit = &get_search_ready($mcrit);

if ($mcrit ne "")
 {
 if ($mtext =~ /$mcrit/i)
	{
	$RETVal = 1;
	#print "FOUND MATCH: $mcrit <br>";
	}
 }

return ($RETVal);

}



sub get_search_ready
{
my ($search_line) = @_;

$reline = $search_line;

$reline =~ s/\+//g;
$reline =~ s/\[//g;
$reline =~ s/\]//g;
$reline =~ s/\)//g;
$reline =~ s/\(//g;
$reline =~ s/\*//g;
$reline =~ s/\^//g;
#$reline =~ s/\.//g;
$reline =~ s/\$//g;
$reline =~ s/\?//g;
$reline =~ s/\\//g;
$reline =~ s/\~//g;
$reline =~ s/<//g;
$reline =~ s/>//g;
$reline =~ s/;//g;

return ($reline);
}




sub whole_match
{

my ($mtext, $mcrit) = @_;
my (@titems, $RETVal);

$RETVal = 0;

$mtext =~ s/\n/ /g;

@tItems = split(/ /,$mtext);

foreach $TWord (@tItems)
	{
	if ($TWord ne "")
	{
	if (lc($TWord) eq lc($mcrit))
		{
		$RETVal = 1;
		#print "FOUND MATCH: $mcrit <br>";
		}
	}
	}

return ($RETVal);

}





sub add_url_instructions
{

$addurl_template = pseek::get_file_contents("$data_dir/add_url_instructions.html");

$addurl_template = pseek::ts_insert_template_includes($addurl_template);
$addurl_template =~ s/!!addurlcgi!!/$script_url\/addurl2.cgi/g;
$addurl_template =~ s/!!scripts_url!!/$script_url/g;

		if ($gsettings->{searchmeth} eq "fulltext")
			{
			$addurl_template =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
			}
			else
			{
			$addurl_template =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
			}

$addurl_template =~ s/!build_url!/$web_url/g;
$addurl_template =~ s/!!build_ursl!!/$web_url/g;
$addurl_template =~ s/!!modify_link_url!!/$script_url\/modify\.cgi/g;
$addurl_template = pseek::fill_vars($addurl_template);
 
print $addurl_template;
exit;

}



sub remove_carriage
{

my($text) = @_;
my ($mcoy, $chr_check, $one_char); 

	#############################################
	### Place <br> in the place of a carriage return

	$one_char = 0;
	$mcoy = "";
	while ($one_char < length($text)) 
		{
		$chr_check = substr($text, $one_char, 1);
		if ($chr_check eq chr(10)) {$chr_check = "";}
		if ($chr_check eq chr(13)) {$chr_check = " ";}
		$mcoy = $mcoy . $chr_check;
		$one_char++;
		}

	return ($mcoy);

}





sub upload_extra_field_file
{

my ($upfbox, $rndfname) = @_;


if ((-e "$data_dir/tmp") < 1) 
	{
	mkdir ("$data_dir/tmp", $default_permissions);
	chmod($default_permissions,"$data_dir/tmp"); 
	}


### GET UPLOAD FILE NAME
$static_counter++;

my @fext = split (/\./, $q->param($upfbox)); $fnr = @fext; $fextension = $fext[$fnr -1];
$rndfname = $rndfname . "_" . $static_counter . "." . $fextension;


### GET UPLOAD FIELD DETAILS
$keysupl = pseek::get_file_contents("$data_dir/keysupl.dat");
@eu_items = split (/:-o_:/, $keysupl);

foreach $uitem (@eu_items)
	{
	($fieldname_t, $filetypes_t, $preappend_t, $append_t, $uploadsize_t, $filetype_error_t, $reqtext_t, $filesize_error_t) = split (/:o:-:o:/, $uitem);
	
	if ($upfbox eq $fieldname_t)	
		{
		
			### CHECK IF EXTENSIONS ARE VALID
			&check_file_upload_extensions($fieldname_t, $filetypes_t, $filetype_error_t);
		
			$upload_filehandle = $q->param($upfbox);
			open UPLOADFILE, "> $data_dir/tmp/$rndfname"; 
				binmode UPLOADFILE; 
				  while ( <$upload_filehandle> )
					 {
				    print UPLOADFILE;
					 } 	
			close UPLOADFILE;		
			
			### CHECK IF FILE SIZE IS VALID
			$flsize = (-s "$data_dir/tmp/$rndfname");
			if ($flsize < 1) { &add_url_problem($filesize_error_t); }
			$uploadsize_t = $uploadsize_t * 1000;
			if ($flsize > $uploadsize_t){ &add_url_problem($filesize_error_t); }
			
		}
	}

return ($rndfname);

}





sub check_file_upload_extensions
{
my ($chk_fieldname, $chk_filetypes, $chk_filetype_error) = @_;

$chk_file_ext = &get_file_extension($q->param($chk_fieldname));
$chk_file_ext = "." . $chk_file_ext;

if ($chk_filetypes ne "*")
	{
	@ext_check_items = split (/,/, $chk_filetypes);
	
	$found_match = "false";
	foreach $e_item (@ext_check_items)
		{
		if ($e_item eq $chk_file_ext) {$found_match = "true";}
		}
	
	if ($found_match eq "false") {  &add_url_problem($chk_filetype_error); }
	}

}





sub add_url_problem
{

my ($error_text2) = @_;

	if ($gsettings->{addurl_reg_system} eq "Yes")
		{
		$addurl_prb = pseek::get_file_contents("$data_dir/rgs_add_url_problem.html");
		}
		else
		{
		$addurl_prb = pseek::get_file_contents("$data_dir/add_url_problem.html");
		}
	
	$addurl_prb =~ s/!!scripts_url!!/$script_url/g;

		if ($gsettings->{searchmeth} eq "fulltext")
		{
		$addurl_prb =~ s/!!tseeksearch!!/$script_url\/search2\.cgi/g;
		}
		else
		{
		$addurl_prb =~ s/!!tseeksearch!!/$script_url\/search\.cgi/g;
		}
	
	$addurl_prb =~ s/!build_url!/$web_url/g;
	$addurl_prb =~ s/!!build_url!!/$web_url/g;
	$addurl_prb = pseek::ts_insert_template_includes($addurl_prb);
	$addurl_prb = pseek::fill_vars($addurl_prb); 
	
	$addurl_prb =~ s/%%problem%%/$error_text2/g;
	print $addurl_prb; 
	
	### CLEAN UP OLD TEMPORARY UPLOADED FILES
	&clean_up_old_uploaded_temp_files;
	exit;

}




sub clean_up_old_uploaded_temp_files
{

if ($randomfname ne "")
	{
	$randomfname_match = $randomfname . "_";
	
		 opendir(DDR,"$data_dir/tmp");
				@bdfiles = readdir(DDR);
				foreach $delfile (@bdfiles)
					{
					$delfstart = substr($delfile, 0, length($randomfname_match));
					
					if (($delfile ne ".") and ($delfile ne "..") and ($delfstart eq $randomfname_match))
						{
						$delstat = unlink ("$data_dir/tmp/$delfile");
						}
						
					}
		closedir (DDR);
	
	}

}



sub add_url_upload_required_problem
{

my ($upkname, $requir_or_ext) = @_;

$keysupl = pseek::get_file_contents("$data_dir/keysupl.dat");
@eu_items = split (/:-o_:/, $keysupl);

foreach $uitem (@eu_items)
	{
	($fieldname_t, $filetypes_t, $preappend_t, $append_t, $uploadsize_t, $filetype_error_t, $reqtext_t, $filesize_error_t) = split (/:o:-:o:/, $uitem);
	
	if ($upkname eq $fieldname_t)	
		{
		if ($requir_or_ext eq "BLANK")
			{
			&add_url_problem($reqtext_t);
			}
			elsif ($requir_or_ext eq "NO_EXTENSION")
			{
			&add_url_problem($filetype_error_t);
			}
		}
	}

}



sub get_file_extension
{
($fullnamem) = @_;

if ($fullnamem !~ /\./) { &add_url_upload_required_problem($keyname, "NO_EXTENSION"); }

my @fext = split (/\./, $fullnamem); 
$fnr = @fext;
$ret_ext = $fext[$fnr -1];

return($ret_ext);
exit;
}



sub get_domain
{
my ($sp_url) = @_;
 
$sp_url =~ s/http:\/\/www\.//gi;
$sp_url =~ s/http:\/\///gi;
@alitems = split (/\//, $sp_url);
$realdomain = $alitems[0];

return($realdomain);
}



sub mkdirps
{
my ($dir_to_create) = @_;

if ((-e $dir_to_create) < 1) 
	{
	mkdir ($dir_to_create, $default_permissions);
	chmod($default_permissions,$dir_to_create); 
	}

}





sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

